<?PHP //func.php
Function format_text($text, $dlzka){  

$text = Trim($text);
$text = HTMLSpecialChars($text); //prevedieme pecilne znaky na ich entity
$text = Str_Replace("\r","",$text); //Win systemy pouvaj ako konce riadkov znak \n ale \r\n (\r tu nieje podstatn, a preto ho odstrnim)
$text = Ereg_Replace("\n{3,}"," \n\n ", $text);
//ak sa v lnku nachdza viac ako 3 svisl konce riadkov nahradme ich dvomi
$text = Str_Replace("\n"," <br> ",$text); //vlastn NL2BR()

$novyText = "";
$slovo = Split("[[:blank:]]+", $text);
//z textu si vytvorm pole, ktorho prvkami bud jednotliv slov

for ($i=0;$i<Count($slovo);$i++):
    // v tomto cykle si zistme, i dan slovo nieje odkaz, a i m kad povolen dku
  $slovo[$i] = Trim($slovo[$i]); //najprv odstrnim prpadn medzery

  if (Eregi("^www\.[a-z0-9]+[a-z0-9\._=/&\?~]*$", $slovo[$i])):
       //slovo je odkaz typu www.nieco.sk  
    if (StrLen($slovo[$i]) > $dlzka):  
          //ak je odkaz dlh, ako je povolen
       $noveSlovo = "<a href=\"http://".$slovo[$i]."\">" . SubStr($slovo[$i], 0, $dlzka-3) . "...</a>"; //zobrazm z odkazu len $dlzka znakov a zvyn nahradm (...)
    else: //odkaz m povolen dku a mem ho zobrazi cel 
       $noveSlovo = "<a href=\"http://".$slovo[$i]."\">" . $slovo[$i] . "</a>";
    endif;

  elseif (Eregi("^http://[a-z0-9]+[a-z0-9\._=/&\?/~]*$", $slovo[$i])):
      //odkaz je typu http://nieco.sk 
    if(StrLen($slovo[$i]) > $dlzka): //a znova to ist
       $noveSlovo = "<a href=\"".$slovo[$i]."\">" . SubStr($slovo[$i],0,$dlzka-3) . "...</a>";
    else: 
       $noveSlovo = "<a href=\"".$slovo[$i]."\">" . $slovo[$i] . "</a>";
    endif;

  elseif (Eregi("^[a-z0-9]+[a-z0-9\._-]*[a-z0-9]+@[a-z0-9]+[a-z0-9\._-]*[a-z0-9]+\.[a-z]{2,3}$", $slovo[$i])):
     //a me to by ete emailov adresa. Regulrny vraz pochdza z lnku Regulrne vrazy II z www.interval.cz */ 
    if(strlen($slovo[$i]) > $dlzka): //do tretice vetko dobr
         //nie som si ist, i emailov adresa me ma maximlne 40 znakov.
       $noveSlovo = "<a href=\"mailto:".$slovo[$i]."\">" . SubStr($slovo[$i],0,80) . "...</a>";
    else:
       $noveSlovo = "<a href=\"mailto:".$slovo[$i]."\">" . $slovo[$i] . "</a>";
    endif;

  else:
      //nejedn sa o idny odkaz, ale o normlne slovo
    if (StrLen($slovo[$i]) > $dlzka): //ak je dlhie...
       $noveSlovo = Chunk_Split($slovo[$i], $dlzka, " ");  /*funkcia chunk_split(retazec, dlzka , lep) rozdel reazec vdy po dka znakov na menie, a spoj ich lepom*/
    else:
       $noveSlovo = $slovo[$i]; //normlne slovo do povolenej dky
    endif;
  endif;

  $novyText .= $noveSlovo . " "; //nakoniec slov znovu pospjame do textu 
endfor;

  $povolene[0] = ">";            $entita[0] = "&gt;";
  $povolene[1] = "<b>";        $entita[1] = "&lt;b>";
  $povolene[2] = "</b>";       $entita[2] = "&lt;/b>";
  $povolene[3] = "<font ";      $entita[3] = "&lt;font";
  $povolene[4] = "</font>";    $entita[4] = "&lt;/font>";
  $povolene[5] = "<a";           $entita[5] = "&lt;a";
  $povolene[6] = "</a>";        $entita[6] = "&lt;/a>";
  $povolene[7] = "&";             $entita[7] = "&amp;";
  $povolene[8] = "<i>";          $entita[8] = "&lt;i>";
  $povolene[9] = "</i>";         $entita[9] = "&lt;/i>"; 
  $povolene[10] = "\"";           $entita[10] = "&quot;"; 

  for ($x=0;$x<Count($povolene);$x++):
     $novyText = Eregi_Replace($entita[$x], $povolene[$x], $novyText);
  endfor;
  return $novyText;
} //nezabudnite funkiu zavrie


Function format_zdroj($celok, $dlzka){

  $TAG = "zdrojovy_kod"; //sem si napte v vlastn tag 
  $pocet_zk = SubStr_Count($celok, "<$TAG>"); //poet otvracch tagov <$TAG> 
  $pocet_end_zk = SubStr_Count($celok, "</$TAG>"); //poet uzatvracch tagov </$TAG>

  if ($pocet_end_zk != $pocet_zk OR $pocet_zk == 0)
      return format_text($celok, $dlzka); //ak nie je rovnak poet otvracch a zatvracch tagov, fcia vrti celok ako text. 
  $koniec = StrRPos ($celok, "</$TAG>") + StrLen("</$TAG>"); //pozcia poslednho tagu </$TAG>. StrRPos had prv pozciu od konca 
  $koniec = SubStr($celok, $koniec); //odrezanie poslednej asti z celku (jedn sa o normlny text) do premennej koniec 

  $table = "<table align=center width=\"90%\">\n\t<tr><td style=\"font-family:Arial; font-size:9pt; padding:2pt\" bgcolor=\"#000000\">";
  $table_end = "</td></tr></table>"; //pripravm si zaiatok a koniec tabuky, ktor bude obklopova zdrojov kd 
  $novy_celok = ""; 

  for ($i=0;$i<$pocet_zk;$i++):
  //tento cyklus vykonme toko krt, kokokrt je pouit <$TAG>

    $start = StrPos($celok,"<$TAG>") + StrLen("<$TAG>"); //pozcia prvho pouitia <$TAG> v reazci $celok, ku ktorej je pripotan dlka tagu
    $dlzka_ZK = StrPos($celok,"</$TAG>") - $start; //dlzka zdrojoveho kodu
    $text = SubStr($celok, 0, $start - StrLen("<$TAG>")); //text ktory sa nachadza pred prvym pouzitim <$TAG>
    $zdroj = SubStr($celok, $start, $dlzka_ZK); // "odreeme" zdrojov kd

    $zdroj = StripSlashes($zdroj); //ete musm  zo zdroja odstrni sptn lomtka, ktor sa (ne)dosadili v zvislosti od nastavenia magic_quotes_runtime v php.ini

    OB_Start(); //zapnem bufferovanie vstupu - to znamen vetko o sa bude ma odosla, sa neodole, ale sa ulo do bufferu, a pokm sa nenaraz na funkciu, ktor buffer vypne.
    Highlight_String(Trim($zdroj)); //odstrnenie prebytonch medzier z koncov a zvraznenie syntaxe vstup funkcie sa ulo do bufferu
    $zdroj = OB_Get_Contents(); //natanie bufferu do premennej zdroj
    ob_end_clean(); //vypnutie bufferu a vymazanie jeho obsahu 

    $farby = Array("h"=>"highlight.html",
                          "c"=>"highlight.comment",
                          "s"=>"highlight.string",
                          "k"=>"highlight.keyword",
                          "d"=>"highlight.default");
/*farby je asociatvne pole, kde idex pola znamen triedu CSS, ktor sa pouije pre dan prvok zdrojovho kdu*/

    while (List($class, $color) = Each ($farby)): //kad index natam do premennej $class a prvok do $farba. Kad farbu nahradm prslunou CSS triedou, m samozrejme etrm bajty vo vstupe
      $farba = "color=\"" . Get_Cfg_Var($color) . "\""; //zistm, ak farba je nastaven v php.ini pre dan element
      $zdroj = Str_Replace("$farba", "class=$class", $zdroj); //nahradm farbu za mnou vytvoren triedu CSS. Toto je vhodn naprklad vtedy, ak nemte zasahova do hp.ini
    endwhile;

  $zdroj = Str_Replace("<code>",$table, $zdroj); //tag code dosadzuje funkcia Hightlight_String na zaiatok a na koniec. Ja ho nahradm tabukou 
  $zdroj = Str_Replace("</code>",$table_end, $zdroj);
  $zdroj = Str_Replace("&nbsp;"," ", $zdroj); //kad aj jednoduch medzera je nahraden nedelitelnou. Ja ju prevediem sp na jednoduch aby som zaetril bajty. 
  $zdroj = Str_Replace("  ","&nbsp; ", $zdroj); //dve medzery za sebou u nahrdzam jednou non breaking a jednou normlnou 

  $NovyCelok .= format_text($text, $dlzka) . $zdroj; //sformtovan text a zdrojov kd pripojm k NovmuCelku 
  $celok = SubStr($celok, $dlzka_ZK + $start + strlen("</$TAG>")); //a od starho odreem u sformtovan as

endfor;

$NovyCelok .= format_text($koniec, $dlzka); //a nesmiem zabudn prida posledn as textu

return $NovyCelok;
}
